@echo off
goto check_Permissions

:check_Permissions
    echo Administrative permissions required. Detecting permissions...

    net session >nul 2>&1
    if %errorLevel% == 0 (
        echo Success: Administrative permissions confirmed.
	GOTO InitiateUninstall1
    ) else (
        echo Failure: Current permissions inadequate. Aborting Uninstall.
    )

    pause >nul

GOTO END
:InitiateUninstall1
REM Suppressing @echo on
echo  ------------------------------
md c:\TempUninstall
REM Finding Gacutil
echo  ------------------------------
if exist "c:\program files\2fa\one\client\support\gacutil.exe" (
    copy "c:\program files\2fa\one\client\support\gacutil.exe" c:\TempUninstall\gacutil.exe
	GOTO ContinueUninstalll
) else (
    echo Gacutil missing from Install Path, checking super secret backup location
)
if exist "c:\temp\gacutil.exe" (
    copy "c:\temp\gacutil.exe" c:\TempUninstall\gacutil.exe
	echo Great Job! Clearly this isn't your first rodeo.
	GOTO ContinueUninstalll
) else (
    echo Gacutil.exe missing from super secret backup location, maybe you should copy it to c:\Temp and I can find it there.
    echo  -------------------------------------------------
    echo  ------  Closing this window in 60 seconds  ------
    echo  ------   Press any key to close it now     ------
    echo  -------------------------------------------------
	@echo on
    timeout /t 60
	GOTO End
)





:ContinueUninstalll
copy "c:\program files\2fa\one\client\support\gacutil.exe" c:\TempUninstall\gacutil.exe
pushd c:\TempUninstall
REM pause
net stop oneservice
net stop riservice
sc delete oneservice
sc delete 2farapidaccesssvc
sc delete riservice
taskkill /f /im slmonitor.exe
taskkill /f /im riclient.exe
taskkill /f /im riadmin.exe
taskkill /f /im one.exe
taskkill /f /im oneadmin.exe
taskkill /f /im chromechannel.exe
REM Now a quick pause to let all those processes die
timeout /t 3
regsvr32 /u /s "c:\program files\2fa\one\client\cardnotify.dll"
rd /q /s "C:\Program Files\2FA"
rd /q /s "C:\Program Files (x86)\2FA"
rd /q /s "C:\Program Files (x86)\InstallShield Installation Information\{0A14C961-96E0-4272-9E72-37FA00119986}"
rd /q /s "C:\Program Files (x86)\InstallShield Installation Information\{0F648F37-3666-462D-BC25-01E94B9D1225}"

gacutil -u 2FACMAD
gacutil -u 2FACMSC
gacutil -u CardNotifierCom
gacutil -u CMCom
gacutil -u CoreCom
gacutil -u DBManager
gacutil -u ForayClassLibrary
gacutil -u ForayDialogs
gacutil -u ForayDialogs.xmlserializers
gacutil -u iclasscardlib
gacutil -u iclasswebapi
gacutil -u utils

taskkill /f /im logonui.exe
del c:\windows\system32\Foray*.dll
del c:\windows\system32\oneservice.exe
del c:\windows\system32\riservice.exe
del c:\windows\system32\slmonitor.exe
del c:\windows\system32\rflibrary.dll
del "C:\Users\Public\Desktop\2FA ONE.lnk"
del "C:\Users\Public\Desktop\RapidIdentity Client.lnk"
del "C:\Users\Public\Desktop\Lock Workstation.lnk"
del c:\windows\system32\rapidaccesssvc.exe
del c:\windows\system32\winbioplugins\2fastorageadapter.dll
del c:\windows\system32\biolibrary.dll
del c:\windows\system32\maglibrary.dll
del c:\windows\system32\Fidolibrary.dll
del c:\windows\system32\rflibrary.dll	

:SoftwareKeys
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Foray" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Foray" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\2FA, Inc." /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Identity Automation, LP" /f
:CredentialProviders
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Provider Filters\{15C19206-2133-4dd9-8CA3-EF9DB8AE8BD4}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CB7395BC-AF05-480A-8C16-2A9A8172CE33}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CB8395BC-AF05-480A-8C16-2A9A8172CE33}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CB9395BC-AF05-480A-8C16-2A9A8172CE33}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CBA395BC-AF05-480A-8C16-2A9A8172CE33}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CBB84461-28A0-4691-8BEF-A14F09C188AE}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CBD71E03-35DE-4478-8E51-128BB10BC241}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{CBB395BC-AF05-480A-8C16-2A9A8172CE33}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{D082E611-DD6D-4A36-9B77-EC933B3E2633}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{4C131C10-372C-4EE7-A882-E2FD16DE36B2}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Authentication\Credential Providers\{96F37AE3-11FA-412D-8891-95B9505AF222}" /f
:InstallInfo
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{0A14C961-96E0-4272-9E72-37FA00119986}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{0A14C961-96E0-4272-9E72-37FA00119986}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{0F648F37-3666-462D-BC25-01E94B9D1225}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{6DB35B2F-6D69-47C0-A370-B391A22E0AF5}" /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\{BE934069-49D8-4A7B-90EB-C6D01552243B}" /f
:StartupFiles
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run" /v ONE /f
REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run" /v SLMonitor /f


:NoClass

REG DELETE "HKEY_CLASSES_ROOT\CoreCom.CoreClass" /f

REG DELETE "HKEY_CLASSES_ROOT\CoreCom.CoreClass\CLSID" /f

REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CoreCom.CoreClass" /f

REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CoreCom.CoreClass\CLSID" /f

REG DELETE "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{B1239C9C-1F38-47EE-98A0-1A9B3FE6A763}" /f

REG DELETE "HKEY_CLASSES_ROOT\CLSID\{B1239C9C-1F38-47EE-98A0-1A9B3FE6A763}" /f
REG DELETE "HKEY_CLASSES_ROOT\CLSID\{96F37AE3-11FA-412D-8891-95B9505AF222}" /f

REG DELETE HKEY_CLASSES_ROOT\CLSID\{15C19206-2133-4dd9-8CA3-EF9DB8AE8BD4} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{4C131C10-372C-4EE7-A882-E2FD16DE36B2} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{96F37AE3-11FA-412D-8891-95B9505AF222} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{C4E80EB5-3613-3F90-B2A7-52649577DBB5} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CB7395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CB8395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CB9395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CBA395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CBB395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CBB84461-28A0-4691-8BEF-A14F09C188AE} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{CBD71E03-35DE-4478-8E51-128BB10BC241} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{D082E611-DD6D-4A36-9B77-EC933B3E2633} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{E9875D94-CDB7-3DE6-A756-2619991CF581} /f
REG DELETE HKEY_CLASSES_ROOT\CLSID\{EF8398E6-D858-3935-B50A-D053971136CE} /f
REG DELETE HKEY_CLASSES_ROOT\Wow6432Node\CLSID\{C4E80EB5-3613-3F90-B2A7-52649577DBB5} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{15C19206-2133-4dd9-8CA3-EF9DB8AE8BD4} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{4C131C10-372C-4EE7-A882-E2FD16DE36B2} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{96F37AE3-11FA-412D-8891-95B9505AF222} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{C4E80EB5-3613-3F90-B2A7-52649577DBB5} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CB7395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CB8395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CB9395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CBA395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CBA5CBAE-2676-3009-865D-30B21C555CDC} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CBB395BC-AF05-480A-8C16-2A9A8172CE33} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CBB84461-28A0-4691-8BEF-A14F09C188AE} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{CBD71E03-35DE-4478-8E51-128BB10BC241} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{D082E611-DD6D-4A36-9B77-EC933B3E2633} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{E9875D94-CDB7-3DE6-A756-2619991CF581} /f
REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{EF8398E6-D858-3935-B50A-D053971136CE} /f


POPD

rd /q /s c:\tempuninstall
echo  ----------------------------------------------------------------------------------
echo  Don't worry about any errors above, I have successfully uninstalled your software.
echo  --------------------     Closing this window in 15 seconds    --------------------
timeout /t 15


:End

